// Andrei-Costin Constantinescu - Oxford University
// O(K ^ 2 * N)
#include <bits/stdc++.h>

using namespace std;

typedef long long int lint;

const int NMAX = 30;
const int KMAX = 100000;

int  N, K;
pair <int, int> nodes[KMAX + 5];
lint dp[KMAX + 5];
bool vis[KMAX + 5];

ifstream fin("fft2d.in");
ofstream fout("fft2d.out");

void read() {
    fin >> N >> K;
    assert(1 <= N && N <= NMAX);
    assert(1 <= K && K <= KMAX);
    for (int i = 1; i <= K; ++ i) {
        fin >> nodes[i].first >> nodes[i].second;
        assert(0 <= nodes[i].first && nodes[i].first < N);
        assert(0 <= nodes[i].second && nodes[i].second < (1 << (N - 1)));
    }
}

inline bool dominates(int hA, int A, int hB, int B) {
    if (hA > hB)
        return false;
    int a = N - hB - 1;
    int b = N - hA - 2;
    for (int i = 0; i + 1 < N; ++ i)
        if ((A & (1 << i)) != (B & (1 << i)) && (i < a || b < i))
            return false;
    return true;
}

/*inline bool dominatesBrute(int hA, int A, int hB, int B) {
    if (hA > hB)
        return false;
    if (hA == hB)
        return A == B;
    const int bit = (1 << (N - hA - 2));
    return dominatesBrute(hA + 1, A, hB, B) ||
           dominatesBrute(hA + 1, A ^ bit, hB, B);
}*/

void dfs(int node) {
    if (vis[node])
        return ;
    vis[node] = true;
    dp[node] = (1 << (N - 1 - nodes[node].first));
    for (int it = 1; it <= K; ++ it)
        if (it != node && dominates(nodes[node].first, nodes[node].second, nodes[it].first, nodes[it].second)) {
            dfs(it);
            dp[node] -= dp[it];
        }
}

lint solveK2() {
    memset(vis, 0, sizeof vis);
    memset(dp, 0, sizeof dp);
    lint ans = (1 << (N - 1));
    ans *= ans;
    for (int i = 1; i <= K; ++ i) {
        if (!vis[i])
            dfs(i);
        ans -= dp[i] * (1LL << nodes[i].first);
    }
    return ans;
}

int main() {
    read();
    fout << solveK2() << '\n';
    return 0;
}
