#include<stdio.h>
#include<algorithm>
#include<map>
using namespace std;

#define level first
#define index second
#define NMAX 100005

int n, k; 
long long d[NMAX], answer, mask[NMAX], put3[NMAX];
pair<int, int> special_nodes[NMAX];
map<long long, long long> mymap;

bool check(pair<int,int> node_A, pair<int, int> node_B) {
	int mask_change = (1 << n) - 1 - (1 << node_A.level) + (1 << node_B.level);
	return (node_A.index & mask_change) == ((node_B.index & mask_change));
}

long long transform(int mask) {
	long long new_mask = 0;
	for(int i = n - 1; i >= 0; i--) {
		new_mask = 3 * new_mask + ((mask & (1 << i)) ? 1 : 0);
	}
	return new_mask;
}

int main () {
	freopen("fft2d.in","r",stdin);
	freopen("fft2d.out","w",stdout);
	
	scanf("%d%d",&n,&k); n--;
	put3[0] = 1;
	for(int i = 1; i <= n; i++)
		put3[i] = 3 * put3[i - 1];
	
	for(int i = 1; i <= k; i++) {
		scanf("%d%d", &special_nodes[i].level, &special_nodes[i].index);
		special_nodes[i].level = n - special_nodes[i].level;
	}
	
	sort(special_nodes + 1, special_nodes + k + 1);
	
	answer = (1LL << (2 * n));
	
	int last_bit = 0;
	for(int i = 1; i <= k; i++) {
		while(special_nodes[i].level > last_bit) {
			for(int j = 1; j < i; j++) {
				mymap[mask[j]] -= d[j];
				if(special_nodes[j].index & (1 << last_bit))
					mask[j] += put3[last_bit];
				else
					mask[j] += 2 * put3[last_bit];
				mymap[mask[j]] += d[j];
			}
			last_bit++;
		}
	
		int num_up = (1 << (n - special_nodes[i].level));
		d[i] = (1 << special_nodes[i].level);

		mask[i] = transform(special_nodes[i].index);
		long long cmask = mask[i];
		for(int j = last_bit - 1; j >= 0; j--) {
			if(special_nodes[i].index & (1 << j))
				cmask += put3[j];
			else
				cmask += 2 * put3[j];
			d[i] -= mymap[cmask];
		}
		
		answer -= d[i] * num_up;
		mymap[mask[i]] += d[i];
		//printf("(%d %d %d) %lld %d\n", i, special_nodes[i].level, special_nodes[i].index, d[i], num_up);
		//printf("---> %lld %lld\n", mask[1], mask[2]);
	}
	
	printf("%lld\n", answer);	
	
	return 0;
}
