// Bogdan Ciobanu
#include <iostream>
#include <fstream>
#include <vector>
 
using namespace std;
 
const int kMaxSize = 5e6;
 
int main() {
    ifstream cin("pscfft.in");
    ofstream cout("pscfft.out");

    int q; cin >> q;
    while (q--> 0) {
        int sigma, needle_length; cin >> needle_length >> sigma;
        vector<int> needle(needle_length);
        for (auto& it : needle) {
            cin >> it;
        }

        int haystack_length = needle_length; 
        for (int i = 0; i < sigma; ++i) {
            if (haystack_length * sigma > kMaxSize) {
                haystack_length = kMaxSize;
                break;
            }
 
            haystack_length *= sigma;
        }
        haystack_length += needle_length;
 
        vector<int> haystack(haystack_length);
        for (int i = 0; i < haystack_length; ++i) {
            haystack[i] = (haystack[i / sigma] + i) % sigma;
        }
        
        vector<int> pi(needle_length);
        for (int i = 1, state = 0; i < needle_length; ++i) {
            while (state and needle[i] != needle[state]) {
                state = pi[state - 1];
            }
            if (needle[state] == needle[i]) {
                ++state;
            }
            pi[i] = state;
        }

        for (int i = 0, state = 0; i < haystack_length; ++i) {
            while (state and needle[state] != haystack[i]) {
                state = pi[state - 1];
            }
            if (needle[state] == haystack[i]) {
                ++state;
            }

            if (state == needle_length) {
                cout << i - needle_length + 1 << '\n';
                goto next_iter;
            }
        }

        cout << -1 << '\n';
        next_iter:;
    }
 
    return 0;
}